
#include <iostream>
#include <sstream>
#include <array>
#include <opencv2/opencv.hpp>

#include <string>
#include <fstream>
#include <boost/tokenizer.hpp>
#include <boost/foreach.hpp>
#include <boost/lexical_cast.hpp>


//o[W擾
#define CV_VERSION_STR CVAUX_STR(CV_MAJOR_VERSION) CVAUX_STR(CV_MINOR_VERSION) CVAUX_STR(CV_SUBMINOR_VERSION)
//rh[h
#ifdef _DEBUG
#define CV_EXT_STR "d.lib"
#else
#define CV_EXT_STR ".lib"
#endif

#pragma comment(lib, "opencv_core"		CV_VERSION_STR CV_EXT_STR)
#pragma comment(lib, "opencv_highgui"	CV_VERSION_STR CV_EXT_STR)
#pragma comment(lib, "opencv_imgproc"	CV_VERSION_STR CV_EXT_STR)
//#pragma comment(lib, "opencv_calib3d"	CV_VERSION_STR CV_EXT_STR)

#include "IntersectionDeterminator.h"

struct CalibrationData {
	int planeID;
	cv::Point3d point[4];	//Lu[Vp̒n_
	cv::Point3d planeNormal, planePosition;
};

class KinectCalibrationMain {
private:
	int state;

	int planeType;
	double planeDistance;

	cv::Mat frame;

	std::vector<IntersectionDeterminator> intersect; //_p

	bool isIntersect; //ǂ
	double intersectionDistance;
	int intersectPlaneID;

	std::vector<struct CalibrationData> calibrationDataList;
	struct CalibrationData newData;
public:

	KinectCalibrationMain(){
		state = 0;
		frame = cv::Mat::zeros(cv::Size(640, 480), CV_8SC3);




		// http://www.sousakuba.com/Programming/gs_plane_line_intersect.html


		load("calibration.dat");
		std::cout << "RTC_Kinect_Calibration" << std::endl;
	}

	void updatePointing(cv::Point3d start, cv::Point3d end){
		int intersectCount = 0;

		//Sƌ
		for(int i = 0; i < intersect.size(); i++) {
			if(intersect[i].update(start, end)) {
				intersectCount += 1;
			}
		}

		//Ă߂I
		if(intersectCount == 0) isIntersect = false;
		else {
			isIntersect = true;

			//ŒZ̕ʂ
			double minDist = DBL_MAX;
			int nearPlaneID = -1;
			for(int i = 0; i < intersect.size(); i++) {
				if(intersect[i].isIntersect()) {
					if(intersect[i].getDistance() < minDist) {
						nearPlaneID = i;
						minDist = intersect[i].getDistance();
					}
				}
			}

			if(nearPlaneID != -1) {
				intersectPlaneID = nearPlaneID;
				intersectionDistance = minDist;
			}
		}
	}

	void initialize(){
		state = 1;

		int key;
		while(true) {
			std::cout << "gpʂ̃^Cv͂Ă" << std::endl;
			std::cout << "0: , 1: ǖ" << std::endl;
			std::cout << ">";
			std::cin >> key;
			if(key == 0 && key == 1) break;
		}
		planeType = key;
		while(true) {
			if(planeType == 0) {
				std::cout << "ݒuĂKinect珰ʂ܂ł̋[mm]͂Ă" << std::endl;
			}
			else if(planeType == 1) {
				std::cout << "ݒuĂKinecǖʂ܂ł̋[mm]͂Ă" << std::endl;
			}
			std::cout << ">";
			std::cin >> key;
			planeDistance = key;
			std::cout << planeDistance << "mmɐݒ肵܂" << std::endl;

			std::cout << "zǖʂ̏" << std::endl;
			intersect.clear();
			//@ȂȂ
			if(planeType == 0) {
				intersect.push_back(IntersectionDeterminator(cv::Point3d(0, -planeDistance, 0), cv::Point3d(0, -1, 0)));	//
			}
			else if(planeType == 1) {
				intersect.push_back(IntersectionDeterminator(cv::Point3d(-planeDistance, 0, 0), cv::Point3d(1, 0, 0)));		//E
				intersect.push_back(IntersectionDeterminator(cv::Point3d(planeDistance, 0, 0), cv::Point3d(-1, 0, 0)));		//
				intersect.push_back(IntersectionDeterminator(cv::Point3d(0, 0, -planeDistance), cv::Point3d(0, 0, -1)));		//
				intersect.push_back(IntersectionDeterminator(cv::Point3d(0, 0, planeDistance), cv::Point3d(0, 0, 1)));		//O
			}
			//intersect.push_back(IntersectionDeterminator(cv::Point3d(0, planeDistance, 0), cv::Point3d(0, 1, 0)));		//V 

			break;
		}

		cv::imshow("Calibration", frame);

		state = 2;
		std::cout << "wāASL[Ă";
	}

	void update(cv::Point3d start, cv::Point3d end){
		//NA
		frame = cv::Mat::zeros(cv::Size(640, 480), CV_8SC3);
		if(state < 2) {
			cv::putText(frame, "ݒł", cv::Point(50, 50), 1, 0.8, cv::Scalar(0, 255, 0), 2);
		}

		char key = cv::waitKey(1);

		if(key == 's') {
			if(state == 2) {
				if(isIntersect) {
					//Lu[VɎgp镽ʂɊւ
					newData.planeID = intersectPlaneID;	//Lu[V镽ʂŒ肷
					newData.planePosition = intersect[newData.planeID].getPlanePosition();
					newData.planeNormal = intersect[newData.planeID].getPlaneNormal();
					//Lu[V_̋L^
					newData.point[0] = intersect[newData.planeID].getIntersectionPoint();

					state = 3;
					std::cout << newData.point[0] << std::endl;
					std::cout << "wāASL[Ă";
				}
			}
			else if(state == 3) {
				//Lu[V_̋L^
				newData.point[1] = intersect[newData.planeID].getIntersectionPoint();
				std::cout << newData.point[1] << std::endl;
				std::cout << "EwāASL[Ă";

				state = 4;
			}
			else if(state == 4) {
				//Lu[V_̋L^
				newData.point[2] = intersect[newData.planeID].getIntersectionPoint();
				std::cout << newData.point[2] << std::endl;
				std::cout << "EwāASL[Ă";
				state = 5;
			}
			else if(state == 5) {
				//Lu[V_̋L^
				newData.point[3] = intersect[newData.planeID].getIntersectionPoint();
				std::cout << newData.point[3] << std::endl;
				//Xgɒǉ
				calibrationDataList.push_back(newData);

				//ۑ
				save();

				state = 0;
				cv::destroyWindow("Calibration");
				initialize();
				return;
			}
		}

		//Ƃ肠_𓾂
		updatePointing(start, end);

		//`
		std::stringstream ss;
		if(isIntersect) {
			cv::putText(frame, "selected", cv::Point(50, 50), 1, 1.2, cv::Scalar(255, 0, 0), 1);
			ss << "plane: " << intersectPlaneID;
			cv::putText(frame, ss.str(), cv::Point(50, 100), 1, 1.2, cv::Scalar(255, 0, 0), 1);
			ss.clear();
			ss << "dist: " << intersectionDistance;
			cv::putText(frame, ss.str(), cv::Point(50, 100), 1, 1.2, cv::Scalar(255, 0, 0), 1);
		}
		else {
			cv::putText(frame, "not selected", cv::Point(50, 50), 1, 0.8, cv::Scalar(255, 0, 0), 1);
		}

		//\
		cv::imshow("Calibration", frame);

	}

	void load(std::string filepath){
		calibrationDataList.clear();

		try {
			std::ifstream ifs;
			std::cout << filepath << "J܂" << std::endl;
			ifs.open(filepath, std::ios::in); // ǂݎpŊJ
			if(ifs.fail()) {
				std::cout << filepath << "J܂ł" << std::endl;
				return;
			}
			std::string str;
			char buf[200];
			cv::Point3d point3d;
			cv::Point point;

			boost::char_separator<char> sep("e ,"); //separator is space or comma.
			//boost::char_separator<char> sep(",", "", boost::keep_empty_tokens);

			typedef boost::tokenizer<boost::char_separator<char> > tokenizer1;

			int lineCount = 0;
			while(!ifs.eof()) {
				ifs.getline(buf, 200);//printf("[%d]%s\n",i,buf);
				if(strlen(buf) <= 3) {
					continue;
				}

				if(buf[0] == '*') continue;

				using boost::lexical_cast;
				str = boost::lexical_cast<std::string>(buf);
				tokenizer1 tok1(str, sep);
				int count = 0;

				if(lineCount % 6 == 0) {
					for(tokenizer1::iterator it = tok1.begin(); it != tok1.end(); ++it) {
						if(count % 3 == 0) newData.planeNormal.x = lexical_cast<int>(*it);
						else if(count % 3 == 1) newData.planeNormal.y = lexical_cast<int>(*it);
						else if(count % 3 == 2) newData.planeNormal.z = lexical_cast<int>(*it);

						count++;
					}
				}
				else if(lineCount % 6 == 1) {
					for(tokenizer1::iterator it = tok1.begin(); it != tok1.end(); ++it) {
						if(count % 3 == 0) newData.planePosition.x = lexical_cast<int>(*it);
						else if(count % 3 == 1) newData.planePosition.y = lexical_cast<int>(*it);
						else if(count % 3 == 2) newData.planePosition.z = lexical_cast<int>(*it);

						count++;
					}
				}
				else if(lineCount % 6 == 2) {
					for(tokenizer1::iterator it = tok1.begin(); it != tok1.end(); ++it) {
						if(count % 2 == 0) newData.point[0].x = lexical_cast<int>(*it);
						else if(count % 2 == 1) newData.point[0].y = lexical_cast<int>(*it);

						count++;
					}
				}
				else if(lineCount % 6 == 3) {
					for(tokenizer1::iterator it = tok1.begin(); it != tok1.end(); ++it) {
						if(count % 2 == 0) newData.point[1].x = lexical_cast<int>(*it);
						else if(count % 2 == 1) newData.point[1].y = lexical_cast<int>(*it);

						count++;
					}
				}
				else if(lineCount % 6 == 4) {
					for(tokenizer1::iterator it = tok1.begin(); it != tok1.end(); ++it) {
						if(count % 2 == 0) newData.point[2].x = lexical_cast<int>(*it);
						else if(count % 2 == 1) newData.point[2].y = lexical_cast<int>(*it);

						count++;
					}
				}
				else if(lineCount % 6 == 5) {
					for(tokenizer1::iterator it = tok1.begin(); it != tok1.end(); ++it) {
						if(count % 2 == 0) newData.point[3].x = lexical_cast<int>(*it);
						else if(count % 2 == 1) newData.point[3].y = lexical_cast<int>(*it);

						count++;
					}

					//Xgɒǉ
					calibrationDataList.push_back(newData);
				}
				lineCount++;
			}

			ifs.close();
		} catch(std::exception &ex) {
			std::cerr << ex.what() << std::endl;
		}

		std::cout << "o^ς݂̃f[^: " << calibrationDataList.size() << std::endl;
	}

	void save(){
		std::ofstream ofs("calibration.dat");

		for(int i = 0; i < calibrationDataList.size(); i++) {
			ofs << calibrationDataList[i].planeNormal.x << "," << calibrationDataList[i].planeNormal.y << "," << calibrationDataList[i].planeNormal.z << std::endl;
			ofs << calibrationDataList[i].planePosition.x << "," << calibrationDataList[i].planePosition.y << "," << calibrationDataList[i].planePosition.z << std::endl;
			for(int j = 0; j < 4; j++) {
				cv::Point outputval = conv3Dto2D(calibrationDataList[i].point[j], calibrationDataList[i].planeNormal);
				ofs << outputval.x << "," << outputval.y << std::endl;
			}
			ofs << "******************************" << std::endl;
		}

		ofs.close();

		std::cout << "calibration.dat" << "o͂܂" << std::endl;
	}

	cv::Point conv3Dto2D(cv::Point3d point3D, cv::Point3d normal){
		cv::Point retval = cv::Point(0, 0);

		if(normal.x == 1) {
			retval.x = point3D.y;
			retval.y = point3D.z;
		}
		else if(normal.x == -1) {
			retval.x = point3D.y;
			retval.y = point3D.z;
		}
		else if(normal.z == -1) {
			retval.x = point3D.x;
			retval.y = point3D.y;
		}
		else if(normal.z == 1) {
			retval.x = point3D.x;
			retval.y = point3D.y;
		}
		else if(normal.y == -1) {
			retval.x = point3D.x;
			retval.y = point3D.z;
		}
		else if(normal.y == 1) {
			retval.x = point3D.x;
			retval.y = point3D.z;
		}

		return retval;
	}

};