#pragma once

#include <Windows.h>
#include <NuiApi.h>
#pragma comment(lib, "Kinect10.lib")

#include "KinectSensor.h"

#include <array>

#include <opencv2/opencv.hpp>

//o[W擾
#define CV_VERSION_STR CVAUX_STR(CV_MAJOR_VERSION) CVAUX_STR(CV_MINOR_VERSION) CVAUX_STR(CV_SUBMINOR_VERSION)
//rh[h
#ifdef _DEBUG
#define CV_EXT_STR "d.lib"
#else
#define CV_EXT_STR ".lib"
#endif

#pragma comment(lib, "opencv_core"		CV_VERSION_STR CV_EXT_STR)
#pragma comment(lib, "opencv_highgui"	CV_VERSION_STR CV_EXT_STR)
#pragma comment(lib, "opencv_imgproc"	CV_VERSION_STR CV_EXT_STR)

class Kinect_JointTrackingMain {
private:
	KinectSensor kinect;

public:
	std::array<float, NUI_SKELETON_POSITION_COUNT * 3> skeleton;

	Kinect_JointTrackingMain() : kinect(NUI_IMAGE_RESOLUTION_640x480, NUI_IMAGE_RESOLUTION_640x480, 0){
		
	}

	~Kinect_JointTrackingMain(){
		kinect.stop();
	}

	void init(){
		kinect.start();
	}

	void update(){
		int result = kinect.updateSensor();

		if(result == 0) {
			if(kinect.getDeviceUpdateSuccessful(1) == true){
				//XPg̃t[擾
				NUI_SKELETON_FRAME skeletonFrame = {0};
				kinect.getKinect()->NuiSkeletonGetNextFrame(0, &skeletonFrame); //s邱Ƃ炵(H_RESULT) ƂŒ

				//X[WO
				NUI_TRANSFORM_SMOOTH_PARAMETERS defaultParams = {0.5f, 0.1f, 0.5f, 0.1f, 0.1f}; //Good for a menu system
				kinect.getKinect()->NuiTransformSmooth(&skeletonFrame, &defaultParams);

				for(int i = 0; i < NUI_SKELETON_COUNT; i++) { //6l܂
					NUI_SKELETON_DATA& skeletonData = skeletonFrame.SkeletonData[i];

					//{[̌𓾂
					if(skeletonData.eTrackingState == NUI_SKELETON_TRACKED) {
						for(int j = 0; j < NUI_SKELETON_POSITION_COUNT; j++) {
							if(skeletonData.eSkeletonPositionTrackingState[j] != NUI_SKELETON_POSITION_NOT_TRACKED) {
								//kinect͓IɃ[gŕ\邽߁A~[gɕϊ
								//http://msdn.microsoft.com/en-us/library/hh973078
								skeleton[j * 3 + 0] = skeletonData.SkeletonPositions[j].x * 1000.0;
								skeleton[j * 3 + 1] = skeletonData.SkeletonPositions[j].y * 1000.0;
								skeleton[j * 3 + 2] = skeletonData.SkeletonPositions[j].z * 1000.0;

								FLOAT depthX = 0, depthY = 0;
								LONG uvx, uvy;

								//WCgdepthl𓾂
								NuiTransformSkeletonToDepthImage(skeletonData.SkeletonPositions[j], &depthX, &depthY, NUI_IMAGE_RESOLUTION_640x480);
							}
						}
					}
				}
			}
		}
	}
};