
#include <opencv2/opencv.hpp>

class IntersectionDeterminator {
private:
	bool intersection;
	cv::Point3d intersectionPoint;
	double intersectionDist;

	cv::Point3d planePosition;
	cv::Point3d planeNormal;
public:
	IntersectionDeterminator(cv::Point3d planePosition, cv::Point3d planeNormal){
		this->planePosition = planePosition;
		this->planeNormal = planeNormal;
	}

	bool update(cv::Point3d start, cv::Point3d end){
		/*
		// _߂
		// http://www.sousakuba.com/Programming/gs_plane_line_intersect.html
		*/
		cv::Point3d l = end - start;				//wxNg
		cv::Point3d a = l * (1.0 / cv::norm(l));	//wɕsȒPʃxNg
		cv::Point3d endPoint = end + a * 10000;		//KɐL΂Ă

		cv::Point3d PA = planePosition - end;
		cv::Point3d PB = planePosition - endPoint;

		double dot_PA = PA.x * planeNormal.x + PA.y * planeNormal.y + PA.z * planeNormal.z;
		double dot_PB = PB.x * planeNormal.x + PB.y * planeNormal.y + PB.z * planeNormal.z;
	
		//
		if(dot_PA == 0.0 && dot_PB == 0.0) {
			//ĂȂ
			intersection = false;
			return false;
		}
		else if((dot_PA >= 0.0 && dot_PB <= 0.0) || (dot_PA <= 0.0 && dot_PB >= 0.0)) {
			//ς̕ЕvXŕЕ}CiXȂ̂ŁAĂ
			intersection = true;
		}
		else {
			//ĂȂ
			intersection = false;
			return false;
		}

		//ȉA_߂ 
		cv::Point3d AB = endPoint - end;

		//_A̋ : _B̋ = dot_PA : dot_PB
		double ratio = abs(dot_PA) / (abs(dot_PA) + abs(dot_PB));

		//_̈ʒúH
		intersectionPoint = end + (AB * ratio);

		//𑪂
		intersectionDist = sqrt((intersectionPoint.x - end.x)*(intersectionPoint.x - end.x)
			+ (intersectionPoint.y - end.y)*(intersectionPoint.y - end.y)
			+ (intersectionPoint.z - end.z)*(intersectionPoint.z - end.z));
	
		return true;
	}

	double getDistance(){
		return intersectionDist;
	}

	bool isIntersect(){
		return intersection;
	}

	cv::Point3d getIntersectionPoint(){
		return intersectionPoint;
	}

	cv::Point3d getPlanePosition(){
		return planePosition;
	}

	cv::Point3d getPlaneNormal(){
		return planeNormal;
	}

};